import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

import javax.swing.*;
import javax.swing.border.*;

import java.util.ArrayList;


@SuppressWarnings("serial")
public class Main extends Applet {
	public static boolean peitjaAktiivne = false;
	public static Numbripaneel manguvali;
	public static JScrollPane kerija;
	public static JButton hide;
	public static JPanel skooripaneel;
	public static JPanel kontrollpaneel;
	//public static ArrayList<Skoor> skoorid = new ArrayList<Skoor>();
	
    public void init() {
        try {
            SwingUtilities.invokeAndWait(new Runnable() {
            	
            	public void run() {
            		//loeSkoorSisse(); //loeb failist skoorid
                	//Kogu asja layout
                	setLayout(new GridLayout(0,2));
	                	JPanel vasak = new JPanel();
	                	vasak.setLayout(new GridLayout(2,1));
	                	
		                	//Lisa kontrollpaneel
		                	kontrollpaneel = new JPanel();
		                	kontrollpaneel.setLayout(new GridLayout(5,1,10,10));
		                	kontrollpaneel.setBorder(new EmptyBorder(30, 30, 30, 30));
		                	
			                	//Numbrite lisamise nupp
			                	JButton lisa = new JButton("Lisa numbrid");
			                    lisa.addActionListener(new ActionListener() {
			                    	public void actionPerformed(ActionEvent e) {
			                        	lisaNumbrid();
			                        }
			                    });
			                    lisa.setMnemonic(KeyEvent.VK_L);
			                    kontrollpaneel.add(lisa);
		                    
			                    //Uuesti alustamine
			                	JButton uus = new JButton("Alusta uuesti");
			                	uus.addActionListener(new ActionListener() {
			                    	public void actionPerformed(ActionEvent e) {
			                    		if(JOptionPane.showConfirmDialog(null, "Oled kindel, et soovid uuesti alustada?\nK�ik su numbrid l�hevad kaduma!", "Oled kindel?",JOptionPane.OK_CANCEL_OPTION) == JOptionPane.OK_OPTION) {
			                    			manguvali.tyhjenda();
			                    			manguvali.teenumbrid(standardAlgus());
			                    		}
			                        }
			                    });
			                	uus.setMnemonic(KeyEvent.VK_A);
			                    kontrollpaneel.add(uus);
		                    
			                    //Vihje n�itamine
			                	JButton hint = new JButton("Vihje");
			                	hint.addActionListener(new ActionListener() {
			                    	public void actionPerformed(ActionEvent e) {
			                    		manguvali.hintinaitaja();
			                        }
			                    });
			                	hint.setMnemonic(KeyEvent.VK_V);
			                    kontrollpaneel.add(hint);
		                    
			                    //Peida t�hjad read
			                    JPanel hidepaneel = new JPanel();
			                    hidepaneel.setLayout(new GridLayout(1,2));
				                	hide = new JButton("Peida t�hijad read");
				                	hide.addActionListener(new ActionListener() {
				                    	public void actionPerformed(ActionEvent e) {
				                        	manguvali.peidaread();
				                        }
				                    });
				                	JCheckBox autohide = new JCheckBox("");
				                	autohide.setMargin(new Insets(0,0,0,0));
				                	autohide.addItemListener(new ItemListener() {
										public void itemStateChanged(ItemEvent e) {
											if(e.getStateChange()==1) {
												hide.setEnabled(false);
												manguvali.peidaread();
												peitjaAktiivne = true;
											}
							                else {
							                	hide.setEnabled(true);
							                	peitjaAktiivne = false;
							                }
							            }
				                	});
				                    hide.add(autohide);
				                	hide.setMnemonic(KeyEvent.VK_P);
				                	//hide.setEnabled(false);
				                	hidepaneel.add(hide);
			                	kontrollpaneel.add(hidepaneel);
			                	
			            skooripaneel = new JPanel();
	                	skooripaneel.setLayout(new GridLayout(9,0,10,10));
	                	skooripaneel.setBorder(new EmptyBorder(30, 30, 30, 30));
	                	
	             /*   	JLabel voitjad = new JLabel("V�itjad", JLabel.CENTER);
	                	voitjad.setFont(new Font("Serif", Font.BOLD, 18));
	                	skooripaneel.add(voitjad);
	                	for(int i=0;i<skoorid.size();i++) {
	                		skooripaneel.add(new JLabel(skoorid.get(i).toString()));
	                		if (i==8) break; //ei taha rohkem kui 10 rida!
	                	}*/
                    
                	//Lisa nupupaneel
                	manguvali = new Numbripaneel(getWidth()/2-16);
             	   	manguvali.teenumbrid(standardAlgus());
                	
                	//Lisa asjad aknasse
             	    add(vasak);
             	   	vasak.add(kontrollpaneel);
             	   	vasak.add(skooripaneel);
             	   	add(manguvali);
                	kerija = new JScrollPane(manguvali);
                	kerija.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
                	kerija.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
                    add(kerija);
                    setVisible(true);
                    kontrollpaneel.revalidate();
                }
            });
        } catch (Exception e) {
            System.err.println("Ei saanud akent tehtud. Kurb :(");
        }
    }

	public static void lisaNumbrid() {
    	manguvali.teenumbrid(manguvali.otsiAllesjaanud());
    	kerija.revalidate();
    	kontrollpaneel.revalidate();
    }
    
    public static ArrayList<String> standardAlgus() {
    	ArrayList<String> numbrid = new ArrayList<String>();
    	for(int i=0;i<27;i++) {
    		Integer a = 1 + (int)(Math.random() * ((5 - 1) + 1));
    		String b = a.toString();
        	numbrid.add(b);
    	}
		return numbrid;
	}
    
/*    public static void loeSkoorSisse() {
    	File fail = new File("skoor.txt"); 
    	java.util.Scanner sc;
		try {
			sc = new java.util.Scanner(fail);
	    	while (sc.hasNextLine()) {
	    	    String rida = sc.nextLine();
	    	    String[] tykid = rida.split(" ");
	    	    if (tykid.length>1) {
		    	    int number = Integer.parseInt(tykid[tykid.length-1]);
		    	    skoorid.add(new Skoor(number,tykid[0]));
	    	    }
	    	}
		} catch (FileNotFoundException e) {
			System.out.println("Skoorifail on kadunud");
		}    
    } */
    
    public static void voit() {
    	String nimi = JOptionPane.showInputDialog(null,	"V�IT!\nSisesta oma nimi", "nimi", JOptionPane.QUESTION_MESSAGE);
    	/*skoorid.add(new Skoor(manguvali.numbrinupud.size(),nimi));
        try {
            BufferedWriter bw = new BufferedWriter(new FileWriter(new File("skoor.txt"), true));
            bw.write(nimi+" "+manguvali.numbrinupud.size());
            bw.newLine();
            bw.close();
        } 
        catch (Exception e) {
        	System.out.println ("Faili kirjutamine eba�nnestus!");
        }*/
    }
}
