import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

@SuppressWarnings("serial")
public class Numbrinupp extends JButton implements ActionListener{

	private boolean must = false;	
	
	//Konstruktor
	public Numbrinupp(String silt, int d) {
		super(silt);		
        setPreferredSize(new Dimension(d, d)); 	// kandilised nupud
        setMargin(new Insets(0,0,0,0));  // numbid näha ka väikestel nuppudel
        teeTavaliseks();
		this.addActionListener(this);
	}
	
	//Teeb konkreetse nupu mustaks ja paneb staatuse külge
	public void teeMustaks() {
		setBackground(Color.BLACK); 
		setEnabled(false);
		must = true;
	}

	public void teeTavaliseks() {setBackground(Color.WHITE); setForeground(Color.BLACK); setEnabled(true);}
	public void teeValituks() {setBackground(Color.GRAY);}
	public void teeHailait() {setBackground(new Color(242,242,242)); }
	public void teeHint() {setForeground(Color.RED); }
	
	//Nupuklikile reageerija
	public void actionPerformed(ActionEvent e) {
		Main.manguvali.teeMidagiNupuga(this);
	}

	//Musta staatuse getter
	public boolean isMust() {
		return must;
	}
}
