import java.awt.*;
import javax.swing.*;
import java.util.ArrayList;

@SuppressWarnings("serial")
public class Numbripaneel extends JPanel {
		
	public ArrayList<Numbrinupp> numbrinupud = new ArrayList<Numbrinupp>();
	
	private boolean valikTehtud = false;
	private Numbrinupp valitud;
	private int a;
	private int pooleliy = 0;
	private int poolelix = 0;
	
	public Numbripaneel(int laius) {
    	setLayout(null);
    	a = laius/9;
	}
	
	//Lisab väärtuste sõne alusel nuppe ja paigutab need paneelile
	public void teenumbrid(ArrayList<String> numbrid) {
		boolean ridaLopetamata = false;
		int x=poolelix;
		int y=pooleliy;
		int index=0;
		while(index < numbrid.size()) {
			while(x<9*a) {
				if(index < numbrid.size()){
					Numbrinupp n = new Numbrinupp(numbrid.get(index), a);
					n.setBounds(x,y,a,a);
					add(n);
					numbrinupud.add(n);
					x+=a;
					index++;
				}
				else {
					ridaLopetamata = true;
					break;
				}
			}
			if(!ridaLopetamata){
				y+=a;
				x=0;
				ridaLopetamata = false;
			}
		}
		poolelix = x;
		pooleliy = y;
		setPreferredSize(new Dimension(100, pooleliy+a));  //laius ei mängi mingit rolli
		repaint();
	}
	
	//Teeb nimekirja allesjäänud (mittemustadest) nuppudest
	public ArrayList<String> otsiAllesjaanud() {
		 ArrayList<String> numbrid = new ArrayList<String>();
		 for(Numbrinupp i: numbrinupud) {
				if(!i.isMust()) {
					numbrid.add(i.getText());
				}
	        }
		 return numbrid;
	 }
	 
	//Kas kehtib kahe numbri vahel vajalik seos
	public boolean numbriValideerija(Numbrinupp a, Numbrinupp b) {
			if(soodsaotsija(a).contains(b)) return true;
			else return false;
	}
			
			
	public int leiaIndeks(Numbrinupp a) {
			//Anname suvalise väärtuse ajutiselt (mis pole listis)
			int aIndex = -1;
			for(int i=0; i<numbrinupud.size(); i++) {
				if (numbrinupud.get(i)==a) {
					aIndex = i; 
					break;
				}
			}
			return aIndex;
	}
	
	//Otsib lähima mittemusta
	public ArrayList<Numbrinupp> otsija(Numbrinupp nupp) {
		int a = leiaIndeks(nupp);
		ArrayList<Numbrinupp> kaigud = new ArrayList<Numbrinupp>();
		for (int i=a+9; i<numbrinupud.size(); i=i+9) {	
			if (!numbrinupud.get(i).isMust()) {
				kaigud.add(numbrinupud.get(i));
				break;
			}
		}
		for (int i=a-9; i>-1; i=i-9) {	
			if (!numbrinupud.get(i).isMust()) {
				kaigud.add(numbrinupud.get(i));
				break;
			}
		}
		for (int i=a-1; i>-1; i--) {	
			if (!numbrinupud.get(i).isMust()) {
				kaigud.add(numbrinupud.get(i));
				break;
			}
		}
		for (int i=a+1; i<numbrinupud.size(); i++) {	
			if (!numbrinupud.get(i).isMust()) {
				kaigud.add(numbrinupud.get(i));
				break;
			}
		}
		return kaigud;
	}
	
	//Millised lähimatest mittemustadest on ka soodsad?
	public ArrayList<Numbrinupp> soodsaotsija(Numbrinupp nupp) {
		ArrayList<Numbrinupp> vomalikudkaigud = otsija(nupp);	
		ArrayList<Numbrinupp> sobivadkaigud = new ArrayList<Numbrinupp>();
		for(Numbrinupp i: vomalikudkaigud) {
			if(nupp.getText().equals(i.getText())) sobivadkaigud.add(i);
		}
		return sobivadkaigud;
	}
	
	//Hintinitaja
	public void hintinaitaja() {
		boolean hintleitud = false;
		for(int i=0; i<numbrinupud.size(); i++) {
			if(!numbrinupud.get(i).isMust() && !soodsaotsija(numbrinupud.get(i)).isEmpty()) {
				numbrinupud.get(i).teeHint();
				soodsaotsija(numbrinupud.get(i)).get(0).teeHint();
				hintleitud = true;
				break;
			}
		}
		if(!hintleitud) {
			JOptionPane.showMessageDialog(null, "Vimalikke kike ei ole!\nkki peaksid numbreid lisama?");
		}
	}
	
	//Nupuklikile reageerija
	public void teeMidagiNupuga(Numbrinupp a) {
		//Määra esimeseks valituks, kui valik pole tehtud
		if (!valikTehtud) {
			a.teeValituks();
			valitud = a;
			valikTehtud = true;
		}
					
		//Kui on valideeritud, siis tee mustaks   
		else if ((a.getText().equals(valitud.getText())) && numbriValideerija(a, valitud)) {
			a.teeMustaks();;
			valitud.teeMustaks();
			valikTehtud = false;
			if(Main.peitjaAktiivne) peidaread();
			if(onVoit()) Main.voit();
		}
		
		//unselect
		else if (a==valitud) {
			a.teeTavaliseks();
			valikTehtud = false;
		}
		
		//Vale valik = reset.
		else {
			a.teeTavaliseks();
			valitud.teeTavaliseks();
			valikTehtud = false;
		} 	
		hailaiter(valitud,valikTehtud);
	}

	public void hailaiter(Numbrinupp a, boolean bol) {
		ArrayList<Numbrinupp> list = otsija(a);
		for(Numbrinupp i: list) {
			if(bol) i.teeHailait();
			else i.teeTavaliseks();
		}
	}
	
	public void tyhjenda() {
		 for(Numbrinupp i: numbrinupud) remove(i);
		 numbrinupud.clear();
		 pooleliy = 0;
		 poolelix = 0;
		 repaint();
	}
	
	public void peidaread() {
		for(int i=0; i<numbrinupud.size()-9;i=i+9) {
			if (numbrinupud.get(i).isMust() && numbrinupud.get(i).isVisible()) {
				boolean mureasonmittemust = false;
				for (int j=1; j<9; j++) {
					if (!numbrinupud.get(i+j).isMust()) {
						mureasonmittemust = true;
						break;
					}
				}
				if (!mureasonmittemust) {
					for (int k=0; k<9; k++) {
						numbrinupud.get(i+k).setVisible(false);
					}
					for (int l=i+9; l<numbrinupud.size(); l++) {
						numbrinupud.get(l).setBounds(numbrinupud.get(l).getBounds().x,numbrinupud.get(l).getBounds().y-a,a,a);
					}
					pooleliy=pooleliy-a;
					Main.kerija.revalidate();
				}
			}
		}
	}

	public boolean onVoit() {
		boolean leidsinvalge = false;
		for(int i=0; i<numbrinupud.size();i++) {
			if(!numbrinupud.get(i).isMust()) {
				leidsinvalge = true;
				break;
			}
		}
		if (leidsinvalge) return false;
		else return true;
	}
}
